// 5 digit

#include <OrderReliable.mqh>

extern string Check1          = "Your broker Sydney open time:";
extern int SydneyOpen         = 23;

extern double Lots            = 1;
extern int RiskPercent        = 0;

extern int Slippage           = 3;

extern bool PriceIn5Digits    = true;

int i, iMagicNumber, iSpread, iTrades, iPip;
string strComment, strExpertName, strResetDate;
bool bTraded, bBuyTraded, bSellTraded, bDone, bWasBuy, bWasSell, bIsBuy, bIsSell, bAllClosed;
double dPivot, dS1, dR1, dBuyThis, dBuySL, dBuyTP, dSellThis, dSellSL, dSellTP, dLotsSold, dLotsBought;
int init() {
   iSpread = MarketInfo( Symbol(), MODE_SPREAD);
   iMagicNumber = 8372;
   strExpertName = "pptr1";
   writeToLog( "init @ " + TimeToStr( TimeCurrent()) +"\n");
}

int start() {
   strComment = "v 0.9 ";
   
   if( PriceIn5Digits) iPip = 10; else iPip = 1;
   
   i = 0;
   while( TimeHour( Time[i]) != SydneyOpen) {
      i++;
   }
   if( i == 0 && ! bAllClosed) {
      closeAll();
      bAllClosed = true;
   }
   strComment = strComment +" i: "+ i;
   if( strResetDate != TimeToStr( TimeCurrent(), TIME_DATE)) {
      iTrades = 0;
      bTraded = false;
      bDone = false;
      bAllClosed = false;
      writeToLog( "reset @ " + TimeToStr( TimeCurrent()) +"\n");
      int iRange = 24;
      double dLow = Low[iLowest( NULL, 0, MODE_LOW, iRange, i)];
      double dHigh = High[iHighest( NULL, 0, MODE_HIGH, iRange, i)];
      dPivot = ( dLow + dHigh + Close[i]) /3;
      dS1 = ( 2*dPivot) - dHigh;
      dR1 = ( 2*dPivot) - dLow;
      writeToLog( "Pivot: " + DoubleToStr( dPivot, Digits) +" R1: "+ DoubleToStr( dR1, Digits) +" S1: "+ DoubleToStr( dS1, Digits) +"\n");
      dBuyThis = dPivot + 10*Point*iPip;
      dBuySL = dBuyThis - 15*Point*iPip;
      dBuyTP = dR1;
      dSellThis = dPivot - 10*Point*iPip;
      dSellSL = dSellThis + 15*Point*iPip;
      dSellTP = dS1;
      writeToLog( "Buy: " + DoubleToStr( dBuyThis, Digits) +" SL: "+ DoubleToStr( dBuySL, Digits) +" TP: "+ DoubleToStr( dBuyTP, Digits) +"\n");
      writeToLog( "Sell: " + DoubleToStr( dSellThis, Digits) +" SL: "+ DoubleToStr( dSellSL, Digits) +" TP: "+ DoubleToStr( dSellTP, Digits) +"\n");
      strResetDate = TimeToStr( TimeCurrent(), TIME_DATE);
 }
   
//---
   bWasBuy = bIsBuy;
   bWasSell = bIsSell; 
   bIsBuy = realTotal( OP_BUY) != 0; 
   bIsSell = realTotal( OP_SELL) != 0;
   if( ( ! bWasSell && bIsSell) || ( ! bWasBuy && bIsBuy)) iTrades++;
   if( bIsBuy) bBuyTraded = true;
   if( bIsSell) bSellTraded = true;
   bTraded = bBuyTraded || bSellTraded; 
//---
   strComment = strComment +" PP: "+ DoubleToStr( dPivot, Digits) +" R1: "+ DoubleToStr( dR1, Digits) +" S1: "+ DoubleToStr( dS1, Digits);
//---   
   bool bBuy = Close[0] >= dBuyThis && Close[0] <= dBuyThis + Slippage*Point*iPip;
   bool bSell = Close[0] <= dSellThis && Close[0] >= dSellThis - Slippage*Point*iPip;
   
   if( bBuy && ! bIsBuy && ! bDone) {
      buy( dBuySL, dBuyTP);
      writeToLog( "Buy @ " + TimeToStr( TimeCurrent()) +" "+ DoubleToStr( Ask, Digits) + "\n");
   }
//---
   if( bSell && ! bIsSell && ! bDone) {
      sell( dSellSL, dSellTP);
      writeToLog( "Sell @ " + TimeToStr( TimeCurrent()) +" "+ DoubleToStr( Bid, Digits) + "\n");
   }
//---
   if( bTraded && Close[0] >= dBuyTP) {
      bDone = true;
      writeToLog( "Buy TP --- EA stopped trading \n");
   }
   if( bTraded && Close[0] <= dSellTP) {
      bDone = true;
      writeToLog( "Sell TP --- EA stopped trading \n");
   }
   if( iTrades >= 8) {
      bDone = true;
      writeToLog( "8 trades --- EA stopped trading \n");
   }
//--------------------------------------------------------------------------------
   Comment( strComment);

   return(0);
}

int realTotal( int OType) {
   int realtotal = 0;
   if( OrdersTotal() > 0)  {
      for( int cnt=0;cnt <= OrdersTotal(); cnt++) {
         OrderSelect( cnt, SELECT_BY_POS, MODE_TRADES);
         if( OrderMagicNumber() == iMagicNumber && OrderSymbol()== Symbol() && OrderType() == OType) {
            realtotal = realtotal+1;
         }
      }
   }
   return( realtotal);
}

void buy( double dBuySL, double dBuyTP) {
   double dLots = calculateVolume();
   OrderSendReliable( Symbol(), OP_BUY, dLots, Ask, Slippage, dBuySL, dBuyTP, strExpertName, iMagicNumber, 0, CLR_NONE);
   dLotsBought = dLots;
}

void sell( double dSellSL, double dSellTP) {
   double dLots = calculateVolume();
   OrderSendReliable( Symbol(), OP_SELL, dLots, Bid, Slippage, dSellSL, dSellTP, strExpertName, iMagicNumber, 0, CLR_NONE);
   dLotsSold = dLots;
}

void closeAll() {
   if( OrdersTotal() > 0)  {
      for( int cnt = 0; cnt <= OrdersTotal(); cnt++) {
         OrderSelect( cnt, SELECT_BY_POS, MODE_TRADES);
         if( OrderMagicNumber() == iMagicNumber && OrderSymbol()== Symbol()) {
            if( OrderType() == OP_BUY)
               OrderCloseReliable( OrderTicket(), dLotsBought, Bid, Slippage, CLR_NONE);
            if( OrderType() == OP_SELL)
               OrderCloseReliable( OrderTicket(), dLotsSold, Ask, Slippage, CLR_NONE);
         }
      }
   }
}

void writeToLog( string str) {
   int h1 = FileOpen( strExpertName + TimeToStr( TimeCurrent(), TIME_DATE)+".txt", FILE_READ|FILE_WRITE);
   FileSeek( h1, 0, SEEK_END);
   FileWrite( h1, str);
   FileClose( h1);
}

double calculateVolume() {
   if ( RiskPercent == 0) {
      return( Lots);
   } else {
      double lot_min  = MarketInfo(Symbol(), MODE_MINLOT);
      double lot_max  = MarketInfo(Symbol(), MODE_MAXLOT);
      double lot_step = MarketInfo(Symbol(), MODE_LOTSTEP);
      double vol = NormalizeDouble( AccountBalance() * RiskPercent / 100000.0, 2);
      vol = NormalizeDouble( vol/lot_step,0)*lot_step;
      if( vol < lot_min) vol = lot_min;
      if( vol > lot_max) vol = lot_max;
      return( vol);
   }
}

